// Code generated by cdpgen. DO NOT EDIT.

package systeminfo

import (
	"encoding/json"
)

// GPUDevice Describes a single graphics processor (GPU).
type GPUDevice struct {
	VendorID     float64 `json:"vendorId"`     // PCI ID of the GPU vendor, if available; 0 otherwise.
	DeviceID     float64 `json:"deviceId"`     // PCI ID of the GPU device, if available; 0 otherwise.
	VendorString string  `json:"vendorString"` // String description of the GPU vendor, if the PCI ID is not available.
	DeviceString string  `json:"deviceString"` // String description of the GPU device, if the PCI ID is not available.
}

// GPUInfo Provides information about the GPU(s) on the system.
type GPUInfo struct {
	Devices              []GPUDevice     `json:"devices"`                 // The graphics devices on the system. Element 0 is the primary GPU.
	AuxAttributes        json.RawMessage `json:"auxAttributes,omitempty"` // An optional dictionary of additional GPU related attributes.
	FeatureStatus        json.RawMessage `json:"featureStatus,omitempty"` // An optional dictionary of graphics features and their status.
	DriverBugWorkarounds []string        `json:"driverBugWorkarounds"`    // An optional array of GPU driver bug workarounds.
}

// ProcessInfo Represents process info.
type ProcessInfo struct {
	Type    string  `json:"type"`    // Specifies process type.
	ID      int     `json:"id"`      // Specifies process id.
	CPUTime float64 `json:"cpuTime"` // Specifies cumulative CPU usage in seconds across all threads of the process since the process start.
}
